package com.ningdatech.pmapi.instance;

import com.alibaba.fastjson.JSON;
import com.ningdatech.pmapi.AppTests;
import com.wflow.workflow.bean.dto.ProcessInstanceUserDto;
import org.flowable.engine.HistoryService;
import org.flowable.engine.RuntimeService;
import org.flowable.engine.history.HistoricActivityInstance;
import org.flowable.engine.runtime.ActivityInstance;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @Classname InstanceTest
 * @Description
 * @Date 2023/2/16 14:44
 * @Author PoffyZhang
 */
public class InstanceTest extends AppTests {

    @Autowired
    private RuntimeService runtimeService;

    @Autowired
    private HistoryService historyService;

    @Test
    public void test(){
        String instanceId = "896fa188-96d8-11ed-9539-e2d4e8f16b2f";
        Object user = runtimeService.getVariable(instanceId,
                "owner");
        System.out.println(JSON.toJSONString(user));
    }

    @Test
    public void testHistory(){
        //如果有已经被审核过的 节点
        List<HistoricActivityInstance> finished = historyService.createHistoricActivityInstanceQuery()
                .processInstanceId("085af7ef-d133-11ed-a3f6-02426daa406d").finished()
                .activityType("userTask")
                .orderByHistoricActivityInstanceEndTime().asc().list();
        HistoricActivityInstance historicActivityInstance = finished.get(0);
        System.out.println(finished);
    }

    @Test
    public void testRuntime(){
        //如果有已经被审核过的 节点
        List<ActivityInstance> userTask = runtimeService.createActivityInstanceQuery()
                .processInstanceId("1709ebe3-d148-11ed-9351-02426daa406d")
                .activityType("userTask")
                .orderByActivityInstanceStartTime().asc().list();
        System.out.println(userTask);
    }
}
